#!hs2
#!load hamster.hsm

#####################################################################
# Skrypt     : Find_MID_From.hsc
# Autor      : Nuta <nuta@konto.pl>
# Strona WWW : http://hamster.thebat.pl
# Wersja     : 2001-08-11
# Poprawki   : 2002-07-03
# ===================================================================
# Opis: Skrypt generujcy list MID'w artykuw ze wszystkich grup
#     : news pochodzcych z podanego adresu nadawcy. Peen opis
#     : dziaania i instalacji skryptu zawarty zosta w doczanym
#     : pliku Find_MID_From.txt.
#####################################################################

HamRequireVersion("1.3.23.4", True)

Var($j, $Ok)
Varset($LiczAll, 0)
Varset($Nadawca, "")
varset($CRLF, Chr(13) + Chr(10))
varset($WSP, Chr(32) + Chr(9))

repeat
  repeat
    repeat
      $Nadawca = InputBox("Wpisz adres autora generowanej listy MID'w (np. login@domena.pl):", "Find_MID_From - lista MID'w wybranego autora", $Nadawca, $Ok)
      if ($Ok=0)
        quit
      endif
    until ($Nadawca <> "")

    if ((pos("@", $Nadawca) = 0) || (pos(".", $Nadawca) = 0))
      MsgBox("Adres: "+$Nadawca+" jest nieprawidowy!"+chr(10)+"Wpisz poprawny adres e-mail nadawcy.", "Find_MID_From - lista MID'w wybranego autora", 0x10|0x0)
    endif
  until ((pos("@", $Nadawca) > 0) && (pos(".", $Nadawca) > 0) && ($Ok <> 0))

  $Nadawca = Replace(Replace(LowerCase(Trim($Nadawca)), "<", "", True), ">", "", True)
  Varset($ListaMID, ListAlloc(True, False))

  if (FileExists(HamPath + $Nadawca+ ".mid"))
    ListLoad($ListaMID, HamPath + $Nadawca + ".mid")
    print("Odczytano plik: " + HamPath + $Nadawca + ".txt")
  else
    ListSave($ListaMID, HamPath + $Nadawca + ".mid")
    print("Utworzono plik: " + HamPath + $Nadawca + ".mid")
  endif

  Varset($ListaGrup, ListAlloc)
  ListLoad($ListaGrup, HamPath + "Groups.hst")

  for ($j, 0, ListCount($ListaGrup)-1)
    Kompletuj_liste_MID(ListGet($ListaGrup,$j))
  endfor

  print
  if ($LiczAll > 0)
    print("cznie dodano do listy MID'y ",$LiczAll," artykuw pochodzcych od nadawcy: ",$Nadawca)
  else
    print("adna grupa nie zawieraa artykuu wysanego z adresu: ",$Nadawca)
  endif

  ListSave($ListaMID, HamPath + $Nadawca + ".mid")

  ListFree($ListaGrup)
  ListFree($ListaMID)

until (Msgbox("Czy ponawiasz prb dla innego zestawu danych?", "Find_MID_From - lista MID'w wybranego autora", 0x20|0x4) = 7)

quit



sub Kompletuj_liste_MID($Grupa)

  Var($OrgTextArt, $Mid, $From, $Stop1)

  Varset($Uchwyt, HamGroupOpen($Grupa))
  Varset($NrArt, HamArtNoMin($Uchwyt))
  Varset($MaxArt, HamArtNoMax($Uchwyt))
  Varset($AllArt, HamArtCount($Uchwyt))
  Varset($MaxAllArt, $MaxArt - $NrArt + 1)
  Varset($LiczArt, 0)
  Varset($Licz, 0)
  Varset($Start1, Ticks)

  if ($AllArt > 0)
    print
    print("Grupa: ",$Grupa," zawiera ",$MaxAllArt," artykuw z czego ",$AllArt," niepustych. Prosz czeka...")
  else
    HamGroupClose($Uchwyt)
    print("Grupa: ",$Grupa," nie zawiera niepustych artykuw do analizy!")
    endsub
  endif

  while ($NrArt <= $MaxArt)
    $OrgTextArt = HamArtText($Uchwyt, $NrArt)
    if ($OrgTextArt <> "")      
      RE_Split($OrgTextArt, $CRLF+$CRLF, $OrgTextArt, )
      $OrgTextArt = $OrgTextArt + $CRLF
      # RE_Parse($OrgTextArt, "\nFrom:\s+(.+@.+)\r", $From)
      $From = RE_Extract($OrgTextArt, $CRLF+"From:.*(("+$CRLF+"["+$WSP+"]).+)*"+$CRLF)
      $From = Copy($From, 9, Len($From) - 10)
      $From = Replace(Replace($From, $CRLF, "", True, True), Chr(9), "", True, True)
      if (pos($Nadawca, LowerCase($From)))
        RE_Parse($OrgTextArt, "\nMessage-ID:\s+<(.+@.+)>\r", $Mid)
        ListAdd($ListaMID, $Mid)
        print("Dopisano Message-ID artykuu nr: ",$NrArt,"  M-ID: ",$Mid)
        inc($Licz)
      endif
      inc($LiczArt)
    endif  
    inc($NrArt)

    $Stop1 = ticks
    if (($Stop1-$Start1) > 30000)
      if ($MaxArt > 99)
        print("Wykonano ",100-Int(($MaxArt-$NrArt)/($MaxArt/100)),"% zadania. Pozostao jeszcze ",$MaxArt-$NrArt," artykuw do analizy. Czekaj...")
      endif
      $Start1 = ticks
    endif
  endwhile

  HamGroupClose($Uchwyt)

  print("W grupie: ",$Grupa," znajdowao si ",$AllArt," niepustych artykuw, z ktrych")
  if ($Licz > 0)
    print($Licz," od nadawcy: ",$Nadawca," dodano do listy MI-D.")
    $LiczAll = $LiczAll + $Licz
  else
    print("aden nie zosta wysany z adresu: ",$Nadawca)
  endif
endsub

